﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using G.MES.ViewModel;
using System.Configuration;
using JWT.Algorithms;
using JWT;
using JWT.Serializers;

namespace Common.Unit
{
    /// <summary>用JWT生成token</summary>
    public class JWTToken
    {
        private static string secret = ConfigurationManager.AppSettings["TokenSecret"].ToString();
        /// <summary>
        /// 生成JWT的token
        /// </summary>
        /// <param name="uid"></param>
        /// <returns></returns>
        public static string Encode(string uid)
        {
            string date = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss");
            TokenInfo info = new TokenInfo { Uid = uid, LoginTime = date };
            IJwtAlgorithm algorithm = new HMACSHA256Algorithm();
            IJsonSerializer serializer = new JsonNetSerializer();
            IBase64UrlEncoder urlEncoder = new JwtBase64UrlEncoder();
            IJwtEncoder encoder = new JwtEncoder(algorithm, serializer, urlEncoder);
            var token = encoder.Encode(info, secret);
            return token;
        }

        /// <summary>
        /// 解析code
        /// </summary>
        /// <param name="token"></param>
        /// <returns></returns>
        public static TokenInfo Decode(string token)
        {
            TokenInfo info = null;
            try
            {
                IJsonSerializer serializer = new JsonNetSerializer();
                IDateTimeProvider provider = new UtcDateTimeProvider();
                IJwtValidator validator = new JwtValidator(serializer, provider);
                IBase64UrlEncoder urlEncoder = new JwtBase64UrlEncoder();
                IJwtDecoder decoder = new JwtDecoder(serializer, validator, urlEncoder);
                info = decoder.DecodeToObject<TokenInfo>(token, secret, verify: true);
            }
            catch (Exception ex)
            { }
            return info;
        }

    }
}
