﻿using Chloe.Infrastructure.Interception;
using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Threading.Tasks;
using G.MES.DataModel;
using G.MES.ViewModel;
using Common.Unit;
using G.Buss.System.ViewModel;
using Model = G.MES.DataModel;
using System.Data.SqlClient;
using System.Text.RegularExpressions;
using G.Buss.System;
using System.Web;

namespace G.MES.API.App_Start
{
    /// <summary>
    /// 
    /// </summary>
    public class DbCommandInterceptor : IDbCommandInterceptor
    {
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteReader() 时调用 */
        public void ReaderExecuting(IDbCommand command, DbCommandInterceptionContext<IDataReader> interceptionContext)
        {
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteReader() 后调用 */
        public void ReaderExecuted(IDbCommand command, DbCommandInterceptionContext<IDataReader> interceptionContext)
        {
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteNonQuery() 时调用 */
        public void NonQueryExecuting(IDbCommand command, DbCommandInterceptionContext<int> interceptionContext)
        {
            try
            {
                string sqlContext = command.CommandText;
                string subText = sqlContext.Substring(0, 1);
                if (subText == "U")
                {
                    Sys_AuditLogSvc logSvc = new Sys_AuditLogSvc();
                    Regex reg = new Regex(@"\[(.+?)\]");
                    string tableName = reg.Matches(sqlContext)[0].Value;
                    int count = reg.Matches(sqlContext).Count;
                    StringBuilder whereSql = new StringBuilder(sqlContext.Substring(sqlContext.IndexOf(" WHERE")));
                    int countTemp = 0;
                    string[] parameters = whereSql.ToString().Split(',');
                    foreach (SqlParameter parameter in command.Parameters)
                    {
                        foreach (string p in parameters)
                        {
                            if (parameter.ParameterName == p.Split('=')[1].Trim())
                            {
                                whereSql.Replace(parameter.ParameterName, "'" + parameter.Value.ToString() + "'");
                            }
                        }
                    }
                    StringBuilder sbQuery = new StringBuilder("SELECT ");
                    for (int i = 1; i < count; i++)
                    {
                        if (reg.Matches(sqlContext)[i].Value == tableName)
                        {
                            countTemp = i;
                        }
                        if (countTemp == 0)
                        {
                            if (reg.Matches(sqlContext)[i + 1].Value == tableName)
                            {
                                sbQuery.Append(reg.Matches(sqlContext)[i].Value);
                            }
                            else
                            {
                                sbQuery.Append(reg.Matches(sqlContext)[i].Value + ",");
                            }
                        }
                    }
                    sbQuery.Append(" FROM " + tableName + " with(nolock) ");
                    sbQuery.Append(whereSql);
                    interceptionContext.DataBag.Add("beforeValue", logSvc.GetBeforeValue(sbQuery.ToString()));
                }

            }
            catch (Exception ex)
            {
                Log4.Write().Error(MethodBase.GetCurrentMethod().Name + ex.Message);
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteNonQuery() 后调用 */
        public void NonQueryExecuted(IDbCommand command, DbCommandInterceptionContext<int> interceptionContext)
        {
            try
            {
                if (interceptionContext.Exception == null)
                {
                    string sqlContext = command.CommandText;
                    HttpRequest request = HttpContext.Current.Request;
                    Sys_AuditLogSvc logSvc = new Sys_AuditLogSvc();
                    string subText = sqlContext.Substring(0, 1);
                    Regex reg = new Regex(@"\[(.+?)\]");
                    string tableName = reg.Matches(sqlContext)[0].Value;
                    int count = reg.Matches(sqlContext).Count;
                    List<Model.Sys_AuditLogDetailed> listLog = new List<Sys_AuditLogDetailed>();
                    if (tableName != "[SystemLogging]" && tableName != "[Sys_AuditLogDetailed]")
                    {
                        if (subText == "I")
                        {
                            Regex reg_insert = new Regex(@"\(.*?\)");
                            string[] parameters = reg_insert.Matches(sqlContext)[1].Value.TrimStart('(').TrimEnd(')').Split(',');
                            for (int i = 1; i < count; i++)
                            {
                                Model.Sys_AuditLogDetailed audit_log = new Model.Sys_AuditLogDetailed();
                                audit_log.AuditOID = Guid.NewGuid();
                                audit_log.TableName = tableName;
                                audit_log.ActionType = "新增记录";
                                audit_log.ActionParameters = reg.Matches(sqlContext)[i].Value;
                                audit_log.UserIP = request.UserHostName;
                                foreach (SqlParameter parameter in command.Parameters)
                                {
                                    if (parameter.ParameterName == parameters[i - 1])
                                    {
                                        audit_log.ActAfterValue = parameter.Value.ToString();
                                        break;
                                    }
                                }
                                listLog.Add(audit_log);
                            }

                        }
                        else if (subText == "U")
                        {
                            List<string> list_beforeValues = (List<string>)(interceptionContext.DataBag["beforeValue"]);
                            string parameterTemp = "";
                            string beforeValue = "";
                            string afterValue = "";
                            for (int i = 1; i < count; i++)
                            {
                                if (reg.Matches(sqlContext)[i].Value == tableName)
                                {
                                    break;
                                }
                                if (reg.Matches(sqlContext)[i + 1].Value == tableName)
                                {
                                    Regex reg_update = new Regex("(?<=(=))[.\\s\\S]*?(?=(\u0020))", RegexOptions.Multiline | RegexOptions.Singleline);
                                    int k = reg_update.Matches(sqlContext)[0].Value.Split('=').Length - 1;
                                    parameterTemp = reg_update.Matches(sqlContext)[0].Value.Split('=')[k];
                                }
                                else
                                {
                                    Regex reg_update = new Regex("(?<=(=))[.\\s\\S]*?(?=(,))", RegexOptions.Multiline | RegexOptions.Singleline);
                                    parameterTemp = reg_update.Matches(sqlContext)[i - 1].Value;
                                }
                                foreach (SqlParameter parameter in command.Parameters)
                                {

                                    if (parameter.ParameterName == parameterTemp)
                                    {
                                        afterValue = parameter.Value.ToString();
                                        break;
                                    }
                                }
                                beforeValue = list_beforeValues[i - 1];
                                if (!beforeValue.Equals(afterValue.Trim()))
                                {
                                    Model.Sys_AuditLogDetailed audit_log = new Model.Sys_AuditLogDetailed();
                                    audit_log.AuditOID = Guid.NewGuid();
                                    audit_log.TableName = tableName;
                                    audit_log.ActionType = "修改记录";
                                    audit_log.ActionParameters = reg.Matches(sqlContext)[i].Value;
                                    audit_log.ActBeforeValue = beforeValue;
                                    audit_log.ActAfterValue = afterValue.Trim();
                                    audit_log.UserIP = request.UserHostName;
                                    listLog.Add(audit_log);
                                }

                            }
                        }
                        else
                        {
                            string parameterTemp = "";
                            Model.Sys_AuditLogDetailed audit_log = new Model.Sys_AuditLogDetailed();
                            audit_log.AuditOID = Guid.NewGuid();
                            audit_log.TableName = tableName;
                            audit_log.ActionType = "删除记录";
                            for (int i = 1; i < count; i++)
                            {
                                parameterTemp = reg.Matches(sqlContext)[i].Value;
                                if (parameterTemp != tableName)
                                {
                                    if (string.IsNullOrEmpty(audit_log.ActionParameters))
                                    {
                                        audit_log.ActionParameters = audit_log.ActionParameters + reg.Matches(sqlContext)[i].Value;
                                    }
                                    else
                                    {
                                        audit_log.ActionParameters = audit_log.ActionParameters + "," + reg.Matches(sqlContext)[i].Value;
                                    }
                                }
                            }
                            foreach (SqlParameter parameter in command.Parameters)
                            {
                                if (string.IsNullOrEmpty(audit_log.ActBeforeValue))
                                {
                                    audit_log.ActBeforeValue = audit_log.ActBeforeValue + parameter.Value.ToString();
                                }
                                else
                                {
                                    audit_log.ActBeforeValue = audit_log.ActBeforeValue + "," + parameter.Value.ToString();
                                }
                            }
                            audit_log.ActAfterValue = null;
                            audit_log.UserIP = request.UserHostName;
                            listLog.Add(audit_log);
                        }
                        logSvc.AddAuditLog(listLog);
                    }
                }
            }
            catch (Exception ex)
            {
                Log4.Write().Error(MethodBase.GetCurrentMethod().Name + ex.Message);
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteScalar() 时调用 */
        public void ScalarExecuting(IDbCommand command, DbCommandInterceptionContext<object> interceptionContext)
        {
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="command"></param>
        /// <param name="interceptionContext"></param>
        /* 执行 DbCommand.ExecuteScalar() 后调用 */
        public void ScalarExecuted(IDbCommand command, DbCommandInterceptionContext<object> interceptionContext)
        {
        }
    }
}