using System.Web.Http;
using WebActivatorEx;
using G.MES.API;
using Swashbuckle.Application;

[assembly: PreApplicationStartMethod(typeof(SwaggerConfig), "Register")]

namespace G.MES.API
{
    public class SwaggerConfig
    {
        public static void Register()
        {
            var thisAssembly = typeof(SwaggerConfig).Assembly;

            GlobalConfiguration.Configuration
                .EnableSwagger(c =>
                    {
                        c.SingleApiVersion("v1", "ӿ");
                        c.IncludeXmlComments(GetXmlCommentsPath());
                        c.DocumentFilter<HiddleAttribute>();
                        c.UseFullTypeNameInSchemaIds();
                    })
                .EnableSwaggerUi(c =>
                    {
                        c.DocumentTitle("ӿ");
                        c.InjectJavaScript(thisAssembly, "G.MES.API.Scripts.Swagger.swagger_lang.js");
                    });
        }
        private static string GetXmlCommentsPath()
        {
            return string.Format("{0}/bin/G.MES.API.xml", System.AppDomain.CurrentDomain.BaseDirectory);
        }
    }
}
