﻿using G.Buss.BaseInfo.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using Common.Unit.Redis;
using G.MES.API.Models;
using System.Web.Http.Controllers;
using System.Net;
using System.Web.Http.Filters;
using System.Net.Http;
using Common.Unit;
using System.Web.ModelBinding;
using G.MES.ViewModel;

namespace G.MES.API
{
    /// <summary>
    /// ApiController接口基类
    /// </summary>
    public class BasicController : ApiController
    {
        /// <summary>
        /// 得到当前登录用户的信息
        /// </summary>
        /// <returns></returns>
        [HiddenApi]
        public LoginInfo GetLoginUser()
        {
            
            string uid = RequestContext.RouteData.Values["LoginUid"].ToString();
            LoginInfo user = null;
            try
            {
                RedisHelper reids = new RedisHelper();
                user = reids.StringGet<LoginInfo>(uid);
            }
            catch { }
            return user;
        }
        /// <summary>
        /// 返回错误信息
        /// </summary>
        /// <param name="msg">错误信息</param>
        /// <param name="msgCode">错误码</param>
        [HiddenApi]
        public void returnWarn(string msg, int msgCode = 0)
        {
             throw new Exception(msgCode + "^" + msg);
            //this.BadRequest(msg);
        }
        /// <summary>
        /// 统一返回模型校验错误
        /// </summary>
        /// <returns></returns>
        [HiddenApi]
        public string ReturnValildMessage()
        {
            return  ModelState.Values.Where(item => { return item.Errors.Count > 0; }).ToList().FirstOrDefault().Errors[0].ErrorMessage.ToString();
        }

    }
}