﻿using G.Buss.BaseInfo.Services.ChemicalDrugReferencesSVC;
using G.Buss.BaseInfo.ViewModel.ChemicalDrugReferencesModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 化药参考文献
    /// </summary>
    public class ChemicalDrugReferencesController:BasicController
    {
        private readonly ChemicalDrugReferencesSVC informed = new ChemicalDrugReferencesSVC();
        /// <summary>
        /// 获取化药参考文献
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public string GetChemicalDrugReferencesTxt()
        {
            LoginInfo user = GetLoginUser();
            try
            {
                return informed.DoGetChemicalDrugReferencesTxt(user);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
        /// <summary>
        /// 保存化药参考文献（带更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveChemicalDrugReferencesTxt(ChemicalDrugReferencesRequestModel requestModel)
        {
            LoginInfo user = GetLoginUser();
            try
            {
                return informed.DoSaveChemicalDrugReferencesTxt(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}