﻿using G.Buss.BaseInfo.Services.GeneSVC;
using G.Buss.BaseInfo.ViewModel.GeneRequestModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 基因
    /// </summary>
    public class GeneController:BasicController
    {
        public readonly GeneSVC Gene = new GeneSVC();
        /// <summary>
        /// 获取基因信息列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetGene(GeneRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return Gene.DoGetGene(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取基因信息表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveGene(List<GeneSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (GeneSaveRequestModel item in requestModel)
                {
                    Gene.DoSaveGene(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存基因信息表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelGene(List<Guid> requestModel)
        {
            try
            {
                return Gene.DoDelGene(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除基因信息表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportGene()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return Gene.DoImportGene(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入基因信息表格：" + ex.Message);
            }

        }
    }
}