﻿using G.Buss.BaseInfo.Services.GeneCorrelationSVC;
using G.Buss.BaseInfo.ViewModel.GeneCorrelationModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 相关基因列表
    /// </summary>
    public class GeneCorrelationController:BasicController
    {
        public readonly GeneCorrelationSVC Correlation = new GeneCorrelationSVC();
        /// <summary>
        /// 相关基因列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetGeneCorrelation(GeneCorrelationRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return Correlation.DoGetGeneCorrelation(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取遗传风险表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveGeneCorrelation(List<GeneCorrelationSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (GeneCorrelationSaveRequestModel item in requestModel)
                {
                    Correlation.DoSaveGeneCorrelation(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存遗传风险表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelGeneCorrelation(List<Guid> requestModel)
        {
            try
            {
                return Correlation.DoDelGeneCorrelation(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除遗传风险表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportGeneCorrelation()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return Correlation.DoImportGeneCorrelation(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入遗传风险表格：" + ex.Message);
            }

        }
    }
}