﻿using G.Buss.BaseInfo.Services.InformedConsentSVC;
using G.Buss.BaseInfo.ViewModel.InformedConsentModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 知情同意书
    /// </summary>
    public class InformedConsentController:BasicController
    {
        private readonly InformedConsentSVC informed = new InformedConsentSVC();
        /// <summary>
        /// 获取知情同意书
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public string GetInformedConsentTxt()
        {
            LoginInfo user = GetLoginUser();
            try 
            {
                return  informed.DoGetInformedConsentTxt(user);
            } catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
        /// <summary>
        /// 保存知情同意书（带更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveInformedConsentTxt(SaveInformedConsentRequestModel requestModel)
        {
            LoginInfo user = GetLoginUser();
            try
            {
                return informed.DoSaveInformedConsentTxt(requestModel,user);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}