﻿using G.Buss.BaseInfo.Services.PMIDSVC;
using G.Buss.BaseInfo.ViewModel.PMIDModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// PIM
    /// </summary>
    public class PMIDController:BasicController
    {
        public readonly PMIDSVC pmid = new PMIDSVC();
        /// <summary>
        /// 获取PMID类型列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetPMID(PMIDRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return pmid.DoGetPMID(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取PMID类型表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SavePMID(List<PMIDSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (PMIDSaveRequestModel item in requestModel)
                {
                    pmid.DoSavePMID(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存PMID类型表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelPMID(List<Guid> requestModel)
        {
            try
            {
                return pmid.DoDelPMID(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除PMID类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportPMID()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return pmid.DoImportPMID(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入PMID类型表格：" + ex.Message);
            }

        }
    }
}