﻿using G.Buss.BaseInfo.Services;
using G.Buss.BaseInfo.ViewModel.SampleControlModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 样本质控
    /// </summary>
    public class SampleControlController:BasicController
    {
        public readonly SampleControlSVC SampleControl = new SampleControlSVC();
        /// <summary>
        /// 获取SampleControl类型列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetSampleControl(SampleControlRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return SampleControl.DoGetSampleControl(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取SampleControl类型表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveSampleControl(List<SampleControlSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (SampleControlSaveRequestModel item in requestModel)
                {
                    SampleControl.DoSaveSampleControl(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存SampleControl类型表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelSampleControl(List<Guid> requestModel)
        {
            try
            {
                return SampleControl.DoDelSampleControl(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除SampleControl类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportSampleControl()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return SampleControl.DoImportSampleControl(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入SampleControl类型表格：" + ex.Message);
            }

        }

    }
}