﻿using G.Buss.BaseInfo.Services.SampleTypeSVC;
using G.Buss.BaseInfo.ViewModel.SampleTypeModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 样本类型
    /// </summary>
    public class SampleTypeController:BasicController
    {

        public readonly SampleTypeSVC sample = new SampleTypeSVC();
        /// <summary>
        /// 获取样本类型列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetSampleType(SampleTypeRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return sample.DoGetSampleType(requestModel,user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取样本类型表格"+ex.Message);
            }
        }

        /// <summary>
        /// 获取所有样本类型
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public List<SampleTypeSelectModel> GetAllSampleType()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return sample.DoGetAllSampleType(user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取样本类型选项" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveSampleType(List<SampleTypeSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (SampleTypeSaveRequestModel item in requestModel)
                {
                    sample.DoSaveSampleType(item, user);
                }
                return true ;
            }
            catch (Exception ex)
            {
                throw new Exception("保存样本类型表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelSampleType(List<Guid> requestModel)
        {
            try
            {
                return sample.DoDelSampleType(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除样本类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportSampleType()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return sample.DoImportSampleType(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入样本类型表格：" + ex.Message);
            }

        } 

    }
}