﻿using G.Buss.BaseInfo.Services.SummarySVC;
using G.MES.API.App_Start;
using G.MES.DataModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 检测结果汇总表
    /// </summary>
    public class SummaryController : BasicController
    {
        private readonly SummarySvc svc = new SummarySvc();

        /// <summary>
        /// 导入检测结果
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        [NoAuthAttribute]
        public bool ImportSummary()
        {
            try
            {
                //LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return svc.ImportSummary(file);
            }
            catch (Exception e)
            {
                throw new Exception("表格导入错误" + e.Message);
            }
        }

        /// <summary>
        /// 获取检测结果所有数据(未分页,此功能暂时可能不需要)
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        [NoAuthAttribute]
        public List<Summary> GetSummaries()
        {
            return svc.GetSummaries();
        }
    }
}