﻿using G.Buss.BaseInfo.Services.TMBGradeSVC;
using G.Buss.BaseInfo.ViewModel.TMBGradeRequestModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// TMB等级
    /// </summary>
    public class TMBGradeController:BasicController
    {
        public readonly TMBGradeSVC Correlation = new TMBGradeSVC();
        /// <summary>
        /// TMB等级列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetTMBGrade(TMBGradeRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return Correlation.DoGetTMBGrade(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取遗传风险表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveTMBGrade(List<TMBGradeSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (TMBGradeSaveRequestModel item in requestModel)
                {
                    Correlation.DoSaveTMBGrade(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存遗传风险表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelTMBGrade(List<Guid> requestModel)
        {
            try
            {
                return Correlation.DoDelTMBGrade(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除遗传风险表格：" + ex.Message);
            }
        }
    }
}