﻿using G.Buss.BaseInfo.Services.TargetedMedicineSVC;
using G.Buss.BaseInfo.ViewModel.TargetedMedicineModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 靶药
    /// </summary>
    public class TargetedMedicineController:BasicController
    {
        public readonly TargetedMedicineSVC targeted = new TargetedMedicineSVC();
        /// <summary>
        /// 获取靶药类型列表
        /// </summary>
        /// <param name="requestModel"></param>
        /// <returns></returns>
        [HttpPost]
        public PageData GetTargetedMedicine(TargetedMedicineRequestModel requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                return targeted.DoGetTargetedMedicine(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception("获取靶药类型表格" + ex.Message);
            }
        }
        /// <summary>
        /// 批量保存（新增或更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveTargetedMedicine(List<TargetedMedicineSaveRequestModel> requestModel)
        {
            try
            {
                LoginInfo user = GetLoginUser();
                foreach (TargetedMedicineSaveRequestModel item in requestModel)
                {
                    targeted.DoSaveTargetedMedicine(item, user);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception("保存靶药类型表格：" + ex.Message);
            }
        }
        /// <summary>
        /// 批量删除 
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool DelTargetedMedicine(List<Guid> requestModel)
        {
            try
            {
                return targeted.DoDelTargetedMedicine(requestModel);
            }
            catch (Exception ex)
            {
                throw new Exception("删除靶药类型表格：" + ex.Message);
            }
        }

        /// <summary>
        /// excel导入
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool ImportTargetedMedicine()
        {
            try
            {
                LoginInfo user = GetLoginUser();
                HttpPostedFile file = HttpContext.Current.Request.Files["Excel"];
                return targeted.DoImportTargetedMedicine(file, user);

            }
            catch (Exception ex)
            {
                throw new Exception("导入靶药类型表格：" + ex.Message);
            }

        }
    }
}