﻿using G.Buss.BaseInfo.Services.TargetedMedicineReferencesSVC;
using G.Buss.BaseInfo.ViewModel.TargetedMedicineReferencesModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;

namespace G.MES.API.Controllers
{
    /// <summary>
    /// 靶药参考文献
    /// </summary>
    public class TargetedMedicineReferencesController:BasicController
    {
        private readonly TargetedMedicineReferencesSVC informed = new TargetedMedicineReferencesSVC();
        /// <summary>
        /// 获取靶药参考文献
        /// </summary>
        /// <returns></returns>
        [HttpGet]
        public string GetTargetedMedicineReferencesTxt()
        {
            LoginInfo user = GetLoginUser();
            try
            {
                return informed.DoGetTargetedMedicineReferencesTxt(user);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
        /// <summary>
        /// 保存靶药参考文献（带更新）
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public bool SaveTargetedMedicineReferencesTxt(TargetedMedicineReferencesRequestModel requestModel)
        {
            LoginInfo user = GetLoginUser();
            try
            {
                return informed.DoSaveTargetedMedicineReferencesTxt(requestModel, user);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }


    }
}