﻿using Chloe.SqlServer;
using G.Buss.BaseInfo.ViewModel;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using G.MES.ViewModel;
using G.MES.DataModel;
using Common.Unit;
using static Common.Unit.Helper.GuidHelper;
using System.Data;
using Chloe.Infrastructure;
using System.Data.SqlClient;
using Chloe;

namespace G.Buss.BaseInfo
{
    public abstract class BaseSvc: IDisposable
    {
        /// <summary>
        /// ORM学习地址：http://www.52chloe.com/Wiki/Document
        /// </summary>
        public static string sqlConn = ConfigurationManager.ConnectionStrings["MainDB"].ToString();
       
        public class MSSqlConnectionFactory : IDbConnectionFactory
        {
            string _connString = null;
            public MSSqlConnectionFactory(string connString)
            {
                this._connString = connString;
            }
            public IDbConnection CreateConnection()
            {
              IDbConnection conn = new SqlConnection(this._connString);
                
                return conn;

            }
        }
        /// <summary>
        /// 插入系统字段
        /// </summary>
        /// <param name="instance"></param>
        /// <param name="loginUserInfo"></param>
        public static void InsertSysField(object instance, LoginInfo loginUserInfo)
        {
             
            if (instance != null && !string.IsNullOrEmpty("SYS_Created"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_Created");
                _findedPropertyInfo.SetValue(instance, DateTime.Now);
            }
            if (instance != null && !string.IsNullOrEmpty("SYS_CreatedBy"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_CreatedBy");
                _findedPropertyInfo.SetValue(instance, loginUserInfo.Sys_UserOID);
            }
            if (instance != null && !string.IsNullOrEmpty("SYS_POSTN"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_POSTN");
                _findedPropertyInfo.SetValue(instance, loginUserInfo.Sys_PostOID);

            }
            if (instance != null && !string.IsNullOrEmpty("SYS_DIVISION"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_DIVISION");
                _findedPropertyInfo.SetValue(instance, loginUserInfo.Sys_DivisionOID);
            }
            if (instance != null && !string.IsNullOrEmpty("SYS_ORG"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_ORG");
                _findedPropertyInfo.SetValue(instance, loginUserInfo.Sys_OrganizeOID);
            }

        }
        public static void UpSysField(object instance, LoginInfo loginUserInfo)
        {

            if (instance != null && !string.IsNullOrEmpty("SYS_LAST_UPD"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_LAST_UPD");
                _findedPropertyInfo.SetValue(instance, DateTime.Now);
            }
          
            if (instance != null && !string.IsNullOrEmpty("SYS_LAST_UPD_BY"))
            {
                PropertyInfo _findedPropertyInfo = instance.GetType().GetProperty("SYS_LAST_UPD_BY");
                _findedPropertyInfo.SetValue(instance, loginUserInfo.Sys_UserOID);

            }
            

        }

        /// <summary>
        /// 获得代码表值
        /// </summary>
        /// <param name="CodeTableID"></param>
        /// <param name="key"></param>
        /// <returns></returns>
        public DropValue DropTable(string CodeTableID, string key,string type)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                var result = new DropValue
                {
                    Key = "",
                    Value = "",
                };
                if (type == "user")
                {
                    var find = context.Query<CodeClassify>().Where(t => t.CodeTableID == CodeTableID)
                        .LeftJoin<CodeValue>((codem, codez) => codem.CodeClassifyOID == codez.CodeClassifyOID).Select(
                            (codem, codez) => new
                            {

                                CodeID = codez.CodeID,
                                CodeName = codez.CodeName
                            }).Where(t => t.CodeID == key.ToString()).FirstOrDefault();
                    if (find != null)
                    {
                        result.Key = find.CodeID;
                        result.Value = find.CodeName;

                    }
                }

                if (type == "sys")
                {
                    var find = context.Query<Initi06>().Where(t => t.CodeTableID == CodeTableID)
                        .LeftJoin<Initi07>((codem, codez) => codem.Initi06OID == codez.Initi06_FK).Select(
                            (codem, codez) => new
                            {

                                CodeID = codez.CodeID,
                                CodeName = codez.CodeName
                            }).Where(t => t.CodeID == key).FirstOrDefault();
                    if (find != null)
                    {
                        result.Key = find.CodeID;
                        result.Value = find.CodeName;

                    }
                }

                return result;
            }
        }

        /// <summary>
        /// 生成有序的guid
        /// </summary>
        /// <returns></returns>
        public static Guid NewDyGuid()
        {
            return GenerateComb();
        }



        /// <summary>
        /// 返回通用试题编号标签
        /// </summary>
        /// <param name="SRName">编码名称</param>
        /// <param name="length">截取长度</param>
        /// <returns></returns>
        public string GetAutoIncReccordNum(string SRName,int length)
        {
            using (var context = new MsSqlContext(sqlConn))
            {


                AutoIncReccord AutoIncR =
                    context.Query<AutoIncReccord>().Where(a => a.SRName == SRName).FirstOrDefault();
                int DefaultNum = 10000;
                string AutoIncReccordNum = "";
                if (AutoIncR != null)
                {
                    DefaultNum = (int) AutoIncR.RecordNumber + 1;
                    AutoIncReccordNum = DefaultNum + "";
                    int startindex = Convert.ToInt32(AutoIncReccordNum.Count()) - Convert.ToInt32(length);
                    AutoIncReccordNum = AutoIncReccordNum.Remove(0, startindex);
                    AutoIncReccordNum = AutoIncR.SRName + AutoIncReccordNum;
                    context.Update<AutoIncReccord>(a => a.SRName == SRName, a => new AutoIncReccord
                    {
                        RecordNumber = DefaultNum
                    });
                    ;
                }
                else
                {
                    Guid guid = Guid.NewGuid();
                    DefaultNum += 1;
                    AutoIncReccordNum = DefaultNum + "";
                    int startindex = Convert.ToInt32(AutoIncReccordNum.Count()) - Convert.ToInt32(length);
                    AutoIncReccordNum = AutoIncReccordNum.Remove(0, startindex);
                    AutoIncReccordNum = SRName + AutoIncReccordNum;
                    context.Insert<AutoIncReccord>(() => new AutoIncReccord
                    {
                        AutoIncReccordOID = guid,
                        SRName = SRName,
                        RecordNumber = DefaultNum
                    });
                    ;
                }

                return AutoIncReccordNum;
            }
        }

        #region IDisposable Support
        IDbContext _dbContext;
        private bool disposedValue = false; // 要检测冗余调用
        //public IDbContext context
        //{
        //    get
        //    {
        //        if (this._dbContext == null)
        //            this._dbContext = new MsSqlContext((new MSSqlConnectionFactory(sqlConn)));
        //        return this._dbContext;
        //    }
        //}
        public   void Dispose()
        {
            if (this._dbContext != null)
            {
                this._dbContext.Dispose();
            }
        }
        #endregion


    }
}
