﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Chloe.SqlServer;
using G.Buss.BaseInfo.ViewModel.AuditLogDetailedModel;
using G.MES.DataModel;

namespace G.Buss.BaseInfo.Services.AuditLogDetailedSVC
{
    public class AuditLogDetailedOperaSVC:BaseSvc
    {
        public GetAuditLogListResponseModel DoGetAllGetAllAuditLogDetailed(Guid requestModel)
        {
            try
            {
                //
                GetAuditLogListResponseModel responseModel = new GetAuditLogListResponseModel();
                List<AuditLogModel> auditLogModelList = new List<AuditLogModel>();
                using (var context = new MsSqlContext(sqlConn))
                {
                    auditLogModelList = context.Query<Sys_AuditLogDetailed>()
                        .Where(a=> (Guid)a.SysytemLogging_FK == requestModel)
                        .Select(a=> new AuditLogModel {
                            AuditOID = a.AuditOID,
                            TableName = a.TableName,
                            ActionParameters = a.ActionParameters,
                            ActBeforeValue = a.ActBeforeValue,
                            ActAfterValue = a.ActAfterValue,
                            ActionType = a.ActionType

                        }).ToList();
                }
                if (auditLogModelList.Count > 0)
                {
                    responseModel.AddAuditLogList = auditLogModelList.Where(a => a.ActionType == "新增记录").ToList();
                    responseModel.UpdateAuditLogList = auditLogModelList.Where(a => a.ActionType == "修改记录").ToList();
                    responseModel.DeleteAuditLogList = auditLogModelList.Where(a => a.ActionType == "删除记录").ToList();

                }
                else
                {
                    responseModel.AddAuditLogList = new List<AuditLogModel>();
                    responseModel.UpdateAuditLogList = new List<AuditLogModel>();
                    responseModel.DeleteAuditLogList = new List<AuditLogModel>();
                }
                return responseModel;
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}
