﻿using Chloe.SqlServer;
using G.Buss.BaseInfo.ViewModel.ChemicalDrugReferencesModel;
using G.MES.DataModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace G.Buss.BaseInfo.Services.ChemicalDrugReferencesSVC
{
    public class ChemicalDrugReferencesSVC:BaseSvc
    {
        public string DoGetChemicalDrugReferencesTxt(LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    string ChemicalDrugReferencesTxt = context.Query<ChemicalDrugReferences>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .Select(a => a.ChemicalDrugReferencesTxt).FirstOrDefault();
                    if (ChemicalDrugReferencesTxt == null)
                    {
                        ChemicalDrugReferencesTxt = "";
                    }
                    return ChemicalDrugReferencesTxt;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
        public bool DoSaveChemicalDrugReferencesTxt(ChemicalDrugReferencesRequestModel requestModel, LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    ChemicalDrugReferences ChemicalDrugReferences = context.Query<ChemicalDrugReferences>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .FirstOrDefault();
                    if (ChemicalDrugReferences == null)//新增
                    {
                        ChemicalDrugReferences = new ChemicalDrugReferences();
                        ChemicalDrugReferences.ChemicalDrugReferencesOID = Guid.NewGuid();
                        ChemicalDrugReferences.ChemicalDrugReferencesTxt = requestModel.ChemicalDrugReferencesTxt;
                        InsertSysField(ChemicalDrugReferences, user);
                        context.Insert(ChemicalDrugReferences);
                    }
                    else//更新
                    {
                        context.TrackEntity(ChemicalDrugReferences);
                        ChemicalDrugReferences.ChemicalDrugReferencesTxt = requestModel.ChemicalDrugReferencesTxt;
                        UpSysField(ChemicalDrugReferences, user);
                        context.Update(ChemicalDrugReferences);
                    }
                    return true;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
    }
}
