﻿using Chloe.SqlServer;
using G.Buss.BaseInfo.Services.SummarySVC;
using G.MES.DataModel;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web;

namespace G.Buss.BaseInfo.Services.ChemotherapySVC
{
    public class ChemotherapySvc : BaseSvc
    {
        /// <summary>
        /// 获取化药结果
        /// </summary>
        /// <returns></returns>
        public List<Chemotherapy> GetChemotherapy()
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                List<Chemotherapy> chemotherapies = context.Query<Chemotherapy>().ToList();
                return chemotherapies;
            }
        }


        public bool ImportChemotherapy(HttpPostedFile file)
        {
            try
            {
                DataTable table = SummarySvc.RenderDataTableFromExcel(file.InputStream, 0, 0);
                List<Chemotherapy> chemotherapys = new List<Chemotherapy>();
                List<string> SampleNumber = new List<string>();
                Guid PreOID = Guid.Empty;
                for (int i = 0; i < table.Rows.Count; i++)
                {
                    Chemotherapy chemotherapy = new Chemotherapy();
                    Guid OID = Guid.NewGuid();
                    if (string.IsNullOrEmpty(table.Rows[i]["药物"].ToString()))
                    {
                        if (PreOID == Guid.Empty)
                        {
                            throw new Exception("excel第一行数据不能为空");
                        }
                        chemotherapy.ParentOID = PreOID;
                        chemotherapy.ChemotherapyOID = OID;
                        chemotherapy.DrugPlan = table.Rows[i]["药物"].ToString();
                        chemotherapy.Gene = table.Rows[i]["基因"].ToString();
                        chemotherapy.TestSite = table.Rows[i]["检测位点"].ToString();
                        chemotherapy.Genotype = table.Rows[i]["基因型"].ToString();
                        chemotherapy.MedicationPrompts = table.Rows[i]["用药提示"].ToString();
                        chemotherapy.Levels = table.Rows[i]["级别"].ToString();
                        //summary.Sys_CreateBy = user.Sys_UserOID;
                        chemotherapy.Sys_Create = DateTime.Now;
                        chemotherapy.CurrentIndex = i;
                    }
                    else
                    {
                        chemotherapy.ParentOID = Guid.Empty;
                        chemotherapy.ChemotherapyOID = OID;
                        chemotherapy.DrugPlan = table.Rows[i]["药物"].ToString();
                        chemotherapy.Gene = table.Rows[i]["基因"].ToString();
                        chemotherapy.TestSite = table.Rows[i]["检测位点"].ToString();
                        chemotherapy.Genotype = table.Rows[i]["基因型"].ToString();
                        chemotherapy.MedicationPrompts = table.Rows[i]["用药提示"].ToString();
                        chemotherapy.Levels = table.Rows[i]["级别"].ToString();
                        chemotherapy.SampleNumber = table.Rows[i]["受试者ID"].ToString();
                        chemotherapy.Sys_Create = DateTime.Now;
                        chemotherapy.CurrentIndex = i;
                        PreOID = OID;
                        SampleNumber.Add(chemotherapy.SampleNumber);
                    }
                    chemotherapys.Add(chemotherapy);
                }
                using (var context = new MsSqlContext(sqlConn))
                {
                    List<Chemotherapy> summarie = context.Query<Chemotherapy>().Where(n => SampleNumber.Contains(n.SampleNumber)).ToList();
                    List<Guid> guids = summarie.Select(n => n.ChemotherapyOID).ToList();
                    List<string> numbers = summarie.Select(n => n.SampleNumber).ToList();
                    //删除已存在的数据再重新插入
                    if (summarie.Any())
                    {
                        context.Delete<Chemotherapy>(m => numbers.Contains(m.SampleNumber) || guids.Contains(m.ParentOID));
                    }
                    context.InsertRange(chemotherapys);
                }
                return true;
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}
