﻿using Chloe.SqlServer;
using G.Buss.BaseInfo.ViewModel.InformedConsentModel;
using G.MES.DataModel;
using G.MES.ViewModel;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace G.Buss.BaseInfo.Services.InformedConsentSVC
{
    public class InformedConsentSVC:BaseSvc
    {
        public string DoGetInformedConsentTxt(LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    string InformedConsentTxt = context.Query<InformedConsent>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .Select(a => a.InformedConsentTxt).FirstOrDefault();
                    if (InformedConsentTxt == null)
                    {
                        InformedConsentTxt = "";
                    }
                    return InformedConsentTxt;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
        public bool DoSaveInformedConsentTxt(SaveInformedConsentRequestModel requestModel, LoginInfo user)
        {
            using (var context = new MsSqlContext(sqlConn))
            {
                try
                {
                    InformedConsent informedConsent = context.Query<InformedConsent>().Where(a => a.SYS_CreatedBy == user.Sys_UserOID)
                        .FirstOrDefault();
                    if (informedConsent == null)//新增
                    {
                        informedConsent = new InformedConsent();
                        informedConsent.InformedConsentOID = Guid.NewGuid();
                        informedConsent.InformedConsentTxt = requestModel.InformedConsentTxt;
                        InsertSysField(informedConsent,user);
                        context.Insert(informedConsent);
                    }
                    else//更新
                    {
                        context.TrackEntity(informedConsent);
                        informedConsent.InformedConsentTxt = requestModel.InformedConsentTxt;
                        UpSysField(informedConsent, user);
                        context.Update(informedConsent);
                    }
                    return true;
                }
                catch (Exception ex)
                {
                    throw new Exception(ex.Message);
                }
            }
        }
    }
}
