﻿using Common.Unit.NetJson;
using G.MES.ViewModel;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace G.Buss.BaseInfo.ViewModel.ClientInfoModel
{
    public class ClientInfoRequestModel:QueryPage
    {
        /// <summary>
        /// 成员姓名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 性别
        /// </summary>
        public int? Sex { get; set; }
        /// <summary>
        /// 身份证
        /// </summary>
        public string IDCard { get; set; }
        /// <summary>
        /// 出生日期
        /// </summary>
        public Comple Birth { get; set; }
        /// <summary>
        /// 样本编码
        /// </summary>
        public string SampleCode { get; set; }
    }
    public class ClientInfoSaveRequestModel
    {
        /// <summary>
        /// 主键
        /// </summary>
        public Guid ClientInfoOID { get; set; }
        /// <summary>
        /// 成员姓名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 性别  1 男 ， 0 女
        /// </summary>
        public int? Sex { get; set; }
        /// <summary>
        /// 身份证
        /// </summary>
        public string IDCard { get; set; }
        /// <summary>
        /// 出生日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? Birth { get; set; }

        /// <summary>
        /// 公司号码
        /// </summary>
        public string CompanyPhone { get; set; }
        /// <summary>
        /// 样本编码
        /// </summary>
        public string SampleCode { get; set; }
        /// <summary>
        /// 样本类型
        /// </summary>
        public string SampleType { get; set; }

        /// <summary>
        /// 采样时间
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]

        public DateTime? SamplingTime { get; set; }
        /// <summary>
        /// 手机号码
        /// </summary>
        public string Phone { get; set; }
        /// <summary>
        /// 样本检测
        /// </summary>
        public string SampleDetection { get; set; }
        /// <summary>
        /// 技术检测
        /// </summary>
        public string TechnologyDetection { get; set; }
        /// <summary>
        /// 肿瘤类型
        /// </summary>
        public string TumorsType { get; set; }
        /// <summary>
        /// TNM分期
        /// </summary>
        public string TNM { get; set; }
        /// <summary>
        /// 是否原发  1 是，0 否
        /// </summary>
        public bool? IsEssential { get; set; }
        /// <summary>
        /// 临床判断
        /// </summary>
        public string ClinicalDiagnosis { get; set; }
        /// <summary>
        /// 家庭病史
        /// </summary>
        public string FamilyHistory { get; set; }
        /// <summary>
        /// 个人病史
        /// </summary>
        public string PersonalHistory { get; set; }

        /// <summary>
        /// 项目名称
        /// </summary>
        public string ItemsName { get; set; }
        /// <summary>
        /// 项目类型
        /// </summary>
        public string ItemsType { get; set; }
        /// <summary>
        /// 实验类型
        /// </summary>
        public string ExperimentalType { get; set; }
        /// <summary>
        /// YK样本编号
        /// </summary>
        public string YKSampleNum { get; set; }
        /// <summary>
        /// 临检号
        /// </summary>
        public string RummageNum { get; set; }
        /// <summary>
        /// 客户样本名称
        /// </summary>
        public string ClientSampleName { get; set; }
        /// <summary>
        /// 癌种/病种
        /// </summary>
        public string Entity { get; set; }
        /// <summary>
        /// 收样日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? ReceivedDate { get; set; }
        /// <summary>
        /// 立项日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? ProjectDate { get; set; }
        /// <summary>
        /// 预计结题日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? NodeTitleDate { get; set; }
        /// <summary>
        /// 样本来源
        /// </summary>
        public string SampleSource { get; set; }
        /// <summary>
        /// 分组情况
        /// </summary>
        public string GroupingSituation { get; set; }
        /// <summary>
        /// ﻿批次
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 捕获探针
        /// </summary>
        public string CaptureProbe { get; set; }
        /// <summary>
        /// 提取人
        /// </summary>
        public string Extracter { get; set; }
        /// <summary>
        /// 质检人
        /// </summary>
        public string QualityPeople { get; set; }
        /// <summary>
        /// 实验操作员
        /// </summary>
        public string LabOperator { get; set; }
        /// <summary>
        /// 外送日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? DeliveryDate { get; set; }
        /// <summary>
        /// index_I5
        /// </summary>
        public string Index_I5 { get; set; }
        /// <summary>
        /// index_I7
        /// </summary>
        public string Index_I7 { get; set; }
        /// <summary>
        /// 文库自身抽检情况
        /// </summary>
        public string SpotCheck { get; set; }
        /// <summary>
        /// 公司质检情况
        /// </summary>
        public string QualityManagement { get; set; }
        /// <summary>
        /// 处理方式
        /// </summary>
        public string ProcessMode { get; set; }
        /// <summary>
        /// 客户数据量要求
        /// </summary>
        public string ClientDataSize { get; set; }
        /// <summary>
        /// 实际下机数据量
        /// </summary>
        public string DeplaneDataSize { get; set; }
        /// <summary>
        /// 加测、补做情况(次数)
        /// </summary>
        public string AdditionalNum { get; set; }
        /// <summary>
        /// 操作失误备注
        /// </summary>
        public string FaultRemark { get; set; }
        /// <summary>
        /// 客户单位
        /// </summary>
        public string ClientUnit { get; set; }
        /// <summary>
        /// 联系邮箱
        /// </summary>
        public string Email { get; set; }
        /// <summary>
        /// 立项编号
        /// </summary>
        public string ProjectNumber { get; set; }
        /// <summary>
        /// 检测平台
        /// </summary>
        public string DetectingPlatform { get; set; }
    }

    public class ClientInfoQueryModel
    {
        /// <summary>
        /// 主键
        /// </summary>
        public Guid ClientInfoOID { get; set; }
        /// <summary>
        /// 成员姓名
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 性别
        /// </summary>
        public int? Sex { get; set; }
        /// <summary>
        /// 身份证
        /// </summary>
        public string IDCard { get; set; }
        /// <summary>
        /// 出生日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? Birth { get; set; }
        /// <summary>
        /// 样本编码
        /// </summary>
        public string SampleCode { get; set; }

        public string ClassCode { get; set; }
    }
    public class ClientInfoDetailModel
    {
        /// <summary>
        /// 主键
        /// </summary>
        public Guid ClientInfoOID { get; set; }
        /// <summary>
        /// 成员姓名
        /// </summary>
        public string Name { get; set; }
        /// <summary>
        /// 性别  1 男 ， 0 女
        /// </summary>
        public int? Sex { get; set; }
        /// <summary>
        /// 身份证
        /// </summary>
        public string IDCard { get; set; }
        /// <summary>
        /// 公司号码
        /// </summary>
        public string CompanyPhone { get; set; }
        /// <summary>
        /// 出生日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? Birth { get; set; }
        /// <summary>
        /// 样本编码
        /// </summary>
        public string SampleCode { get; set; }
        /// <summary>
        /// 样本类型
        /// </summary>
        public string SampleType { get; set; }

        [JsonConverter(typeof(ShortDateFormat))]

        public DateTime? SamplingTime { get; set; }
        /// <summary>
        /// 手机号码
        /// </summary>
        public string Phone { get; set; }
        /// <summary>
        /// 样本检测
        /// </summary>
        public string SampleDetection { get; set; }
        /// <summary>
        /// 技术检测
        /// </summary>
        public string TechnologyDetection { get; set; }
        /// <summary>
        /// 肿瘤类型
        /// </summary>
        public string TumorsType { get; set; }
        /// <summary>
        /// TNM分期
        /// </summary>
        public string TNM { get; set; }
        /// <summary>
        /// 是否原发  1 是，0 否
        /// </summary>
        public bool? IsEssential { get; set; }
        /// <summary>
        /// 临床判断
        /// </summary>
        public string ClinicalDiagnosis { get; set; }
        /// <summary>
        /// 家庭病史
        /// </summary>
        public string FamilyHistory { get; set; }
        /// <summary>
        /// 个人病史
        /// </summary>
        public string PersonalHistory { get; set; }
        /// <summary>
        /// 项目名称
        /// </summary>
        public string ItemsName { get; set; }
        /// <summary>
        /// 项目类型
        /// </summary>
        public string ItemsType { get; set; }
        /// <summary>
        /// 实验类型
        /// </summary>
        public string ExperimentalType { get; set; }
        /// <summary>
        /// YK样本编号
        /// </summary>
        public string YKSampleNum { get; set; }
        /// <summary>
        /// 临检号
        /// </summary>
        public string RummageNum { get; set; }
        /// <summary>
        /// 客户样本名称
        /// </summary>
        public string ClientSampleName { get; set; }
        /// <summary>
        /// 癌种/病种
        /// </summary>
        public string Entity { get; set; }
        /// <summary>
        /// 收样日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? ReceivedDate { get; set; }
        /// <summary>
        /// 立项日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? ProjectDate { get; set; }
        /// <summary>
        /// 预计结题日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? NodeTitleDate { get; set; }
        /// <summary>
        /// 样本来源
        /// </summary>
        public string SampleSource { get; set; }
        /// <summary>
        /// 分组情况
        /// </summary>
        public string GroupingSituation { get; set; }
        /// <summary>
        /// ﻿批次
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 捕获探针
        /// </summary>
        public string CaptureProbe { get; set; }
        /// <summary>
        /// 提取人
        /// </summary>
        public string Extracter { get; set; }
        /// <summary>
        /// 质检人
        /// </summary>
        public string QualityPeople { get; set; }
        /// <summary>
        /// 实验操作员
        /// </summary>
        public string LabOperator { get; set; }
        /// <summary>
        /// 外送日期
        /// </summary>
        [JsonConverter(typeof(ShortDateFormat))]
        public DateTime? DeliveryDate { get; set; }
        /// <summary>
        /// index_I5
        /// </summary>
        public string Index_I5 { get; set; }
        /// <summary>
        /// index_I7
        /// </summary>
        public string Index_I7 { get; set; }
        /// <summary>
        /// 文库自身抽检情况
        /// </summary>
        public string SpotCheck { get; set; }
        /// <summary>
        /// 公司质检情况
        /// </summary>
        public string QualityManagement { get; set; }
        /// <summary>
        /// 处理方式
        /// </summary>
        public string ProcessMode { get; set; }
        /// <summary>
        /// 客户数据量要求
        /// </summary>
        public string ClientDataSize{ get; set; }
        /// <summary>
        /// 实际下机数据量
        /// </summary>
        public string DeplaneDataSize { get; set; }
        /// <summary>
        /// 加测、补做情况(次数)
        /// </summary>
        public string AdditionalNum { get; set; }
        /// <summary>
        /// 操作失误备注
        /// </summary>
        public string FaultRemark { get; set; }
        /// <summary>
        /// 客户单位
        /// </summary>
        public string ClientUnit { get; set; }
        /// <summary>
        /// 联系邮箱
        /// </summary>
        public string Email { get; set; }
        /// <summary>
        /// 立项编号
        /// </summary>
        public string ProjectNumber { get; set; }
        /// <summary>
        /// 检测平台
        /// </summary>
        public string DetectingPlatform { get; set; }
        /// <summary>
        /// 客户流量选项数据
        /// </summary>
        public List<CodeValueIDAndValueModel> ClientDataSizeList { get; set; }

    }

    public class CodeValueIDAndValueModel { 
        /// <summary>
        /// 编码
        /// </summary>
        public string CodeID { get; set; }
        /// <summary>
        /// 名称
        /// </summary>
        public string CodeName { get; set; }
    }
}
