﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Chloe;
using Common.Unit;
using G.MES.DataModel;

namespace G.Buss.System
{
    /// <summary>
    /// 选择服务
    /// </summary>
    public class ChooseSvc:BaseSvc
    {

        public List<ViewModel.PostTreeInfo> PostTreeChoose(string Name)
        {
            List<ViewModel.PostTreeInfo> list_TreeInfos = new List<ViewModel.PostTreeInfo>();

           //没有名称
            if (string.IsNullOrEmpty(Name))
            {
                var alllist = context.Query<Sys_Organize>();
                var find_post = context.Query<Sys_Post>();

                var find_parentList = context.Query<Sys_Organize>().Where(t => t.ParentOID == Guid.Empty).OrderBy(t => t.SortNo);
                foreach (var item in find_parentList.ToList())
                {
                    ViewModel.PostTreeInfo v_tree = new ViewModel.PostTreeInfo();
                    v_tree.OID = item.Sys_OrganizeOID;
                    v_tree.NAME = item.OrgName;
                    v_tree.ISBM = true;
                    v_tree.icon= item.ORG_FLG == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;

                    v_tree.children = BuilTree(alllist, item.Sys_OrganizeOID, find_post);
                    list_TreeInfos.Add(v_tree);

                }

            }
            else
            {
                //找出有多个这个名称岗位
                var find_post = context.Query<Sys_Post>().Where(t => t.PostName.Contains(Name));

                var find_only_bm = find_post.GroupBy(t => t.Sys_DivisionOID).Select(a => new
                {
                    Sys_DivisionOID = a.Sys_DivisionOID
                });

                //找祖先的部门

                Dictionary<Guid, string> dic = new Dictionary<Guid, string>();
                //先递归，再向上找
                foreach (var item in find_only_bm.ToList())
                {
                    var findresult = context.SqlQuery< ViewModel.GET_ORGTreeInfo>("SELECT OrgOID,LEVEL_NUM,T1.PARENTOID,T2.OrgName FROM dbo.FN_GET_ORG(@org,1) T1 LEFT OUTER JOIN  dbo.Sys_Organize T2  ON T1.OrgOID = T2.Sys_OrganizeOID", 
                        new DbParam("@org", item.Sys_DivisionOID.ToString())).OrderByDescending( t=> t.LEVEL_NUM).FirstOrDefault();
                    if (!dic.ContainsKey(findresult.OrgOID))
                    {
                        dic.Add(findresult.OrgOID, findresult.OrgName);

                    }  
                }
                var alllist = context.Query<Sys_Organize>();
                foreach (var item in dic)
                {
                    ViewModel.PostTreeInfo v_tree = new ViewModel.PostTreeInfo();

                    int org_flg = alllist.Where(t => t.Sys_OrganizeOID == item.Key).FirstOrDefault().ORG_FLG;
                    v_tree.OID = item.Key;
                    v_tree.NAME = item.Value;
                    v_tree.ISBM = true;
                    v_tree.icon = org_flg == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;

                    v_tree.children = BuilTree(alllist, item.Key, find_post);
                    list_TreeInfos.Add(v_tree);
                }


            }
            return list_TreeInfos;
        }
        public List<ViewModel.PostTreeInfo> BuilTree(Chloe.IQuery<Sys_Organize> list_treee2, Guid parentOID ,IQuery<Sys_Post> list_post)
        {
            List<ViewModel.PostTreeInfo> list_view_zree = new List<ViewModel.PostTreeInfo>();
            var where = new LamadaExtention<Sys_Organize>();
            
    
            where.And(t=>t.ParentOID==parentOID);

            var findlist = list_treee2.Where(where.GetLambda()).OrderBy(t => t.SortNo).ToList();
            //列出岗位
            var find_post = list_post.Where(t => t.Sys_DivisionOID == parentOID);


            foreach (var item in findlist)
            {
                ViewModel.PostTreeInfo ztree = new ViewModel.PostTreeInfo();

                ztree.NAME = item.OrgName;
                ztree.OID = item.Sys_OrganizeOID;
                ztree.ISBM = true;
                ztree.icon=  item.ORG_FLG == 1 ? ViewModel.icon.systemicon.orgicon : ViewModel.icon.systemicon.bmicon;

                ztree.children = BuilTree(list_treee2, item.Sys_OrganizeOID, list_post);
                list_view_zree.Add(ztree);
            }
            //处理部门下的岗位
            foreach (var item in find_post.ToList())
            {
                ViewModel.PostTreeInfo ztree = new ViewModel.PostTreeInfo();
                ztree.NAME = item.PostName;
                ztree.OID = item.Sys_PostOID;
                ztree.ISBM = false;
                ztree.icon = ViewModel.icon.systemicon.posticon;

                list_view_zree.Add(ztree);

            }
            return list_view_zree;
            }
         
          
        
    }
}
