﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Chloe;
using G.Buss.BaseInfo;
using G.MES.DataModel;
using G.MES.ViewModel;


namespace G.Buss.System
{
    public class NewMenuPermissionSvc : BaseSvc
    {
        /// <summary>
        /// 得到普通用户的菜单
        /// </summary>
        /// <param name="loginInfo"></param>
        /// <returns></returns>
        public List<ViewModel.Sys_BusiPortalMenu> GetUserMenu(LoginInfo loginInfo)
        {
            //获取公共的责任
            var query_resp_common = context.Query<Sys_RESPONSIBILITY>().Where(t => t.IsSYS == true && t.IsDisable == false).ToList();

            Guid? PostOID = loginInfo.Sys_PostOID;

            //获取这个岗位有哪些职责
            var post_resp = context.JoinQuery<Sys_POSTN_RESP_MAP, Sys_RESPONSIBILITY>((map, resp) => new object[]
                {
                JoinType.LeftJoin, map.Sys_RESPONSIBILITY_FK == resp.Sys_RESPONSIBILITYOID         /* 表 User 和 City 进行Left连接 */

                })
            .Select((map, resp) => new
            {
                Sys_RESPONSIBILITY_FK = map.Sys_RESPONSIBILITY_FK,
                IsDisable = resp.IsDisable

            })  /* 投影成匿名对象 */
            .Where(a => a.IsDisable == false).Select((a) => new
            {
                Sys_RESPONSIBILITY_FK = a.Sys_RESPONSIBILITY_FK
            }).ToList();

            List<Guid> list_zz = new List<Guid>();
            //装入公共职责
            foreach (var item in query_resp_common)
            {
                Guid Sys_RESPONSIBILITYOID = item.Sys_RESPONSIBILITYOID;

                if (list_zz.Where(t => t == Sys_RESPONSIBILITYOID).Count() == 0)
                {
                    list_zz.Add(Sys_RESPONSIBILITYOID);
                }
            }
            //装入岗位下的职责
            foreach (var item in post_resp)
            {
                Guid Sys_RESPONSIBILITYOID = item.Sys_RESPONSIBILITY_FK;

                if (list_zz.Where(t => t == Sys_RESPONSIBILITYOID).Count() == 0)
                {
                    list_zz.Add(Sys_RESPONSIBILITYOID);
                }
            }
            //得到唯一的菜单
            List<Guid> porttalmenu_map = context.JoinQuery<Sys_RESPONSIBILITYBPOMAP, Sys_BusiPortalMenu>((map, menu) => new object[]
                   {
                JoinType.LeftJoin, map.Sys_BusiPortalMenu_FK == menu.Sys_BusiPortalMenuOID         /* 表 User 和 City 进行Left连接 */

                   })
               .Select((map, menu) => new
               {
                   OID = map.Sys_BusiPortalMenu_FK,
                   IsStopUsing = menu.IsStopUsing,
                   Sys_RESPONSIBILITY_FK = map.Sys_RESPONSIBILITY_FK//职责外键


            }).Where(a => list_zz.Contains(a.Sys_RESPONSIBILITY_FK) && a.IsStopUsing == false)
               .GroupBy(t => t.OID).Select((a) => a.OID)
               .ToList();

            List<Sys_BusiPortalMenu> list_qx_portmenu = context.Query<Sys_BusiPortalMenu>()
                .Where(t => porttalmenu_map.Contains(t.Sys_BusiPortalMenuOID)).ToList();

            List<ViewModel.Sys_BusiPortalMenu> list_view_zree = new List<ViewModel.Sys_BusiPortalMenu>();
            var parent_list_qx_portmenu = list_qx_portmenu.Where(t => t.ParentOID == Guid.Empty).OrderBy(t => t.SortNo);
            foreach (var item in parent_list_qx_portmenu)
            {
                ViewModel.Sys_BusiPortalMenu ztree = new ViewModel.Sys_BusiPortalMenu();
                ztree.Sys_BusiPortalMenuOID = item.Sys_BusiPortalMenuOID;
                ztree.Name = item.Name;
                ztree.LinkBusiType = item.LinkBusiType;
                ztree.Route = item.Route;
                ztree.ImageLink = item.ImageLink;
                ztree.Param = item.Param;
                ztree.ParentOID = item.ParentOID;
                ztree.SortNo = item.SortNo;
                ztree.IsStopUsing = item.IsStopUsing;
                ztree.OpenMode = item.OpenMode;
                ztree.leves = 1;

                ztree.children = BuilTree(list_qx_portmenu, item.Sys_BusiPortalMenuOID, 1);
                list_view_zree.Add(ztree);
            }
            return list_view_zree;
        }


        public List<ViewModel.Sys_BusiPortalMenu> BuilTree(List<Sys_BusiPortalMenu> list_treee2, Guid parentOID, int leves)
        {
            List<ViewModel.Sys_BusiPortalMenu> list_view_zree = new List<ViewModel.Sys_BusiPortalMenu>();

            var findlist = list_treee2.Where(t => t.ParentOID == parentOID).OrderBy(t => t.SortNo).ToList();

            leves++;
            foreach (var item in findlist)
            {
                ViewModel.Sys_BusiPortalMenu ztree = new ViewModel.Sys_BusiPortalMenu();
                ztree.Sys_BusiPortalMenuOID = item.Sys_BusiPortalMenuOID;
                ztree.Name = item.Name;
                ztree.LinkBusiType = item.LinkBusiType;
                ztree.Route = item.Route;
                ztree.ImageLink = item.ImageLink;
                ztree.Param = item.Param;
                ztree.ParentOID = item.ParentOID;
                ztree.SortNo = item.SortNo;
                ztree.IsStopUsing = item.IsStopUsing;
                ztree.OpenMode = item.OpenMode;
                ztree.leves = leves;

                ztree.children = BuilTree(list_treee2, item.Sys_BusiPortalMenuOID, leves);
                list_view_zree.Add(ztree);
            }
            return list_view_zree;
        }
        /// <summary>
        /// 得到系统管理员的
        /// </summary>
        /// <param name="loginInfo"></param>
        /// <returns></returns>
        public List<ViewModel.Sys_BusiPortalMenu> GetSysMenu(LoginInfo loginInfo)
        {
            List<Sys_BusiPortalMenu> list_qx_portmenu = context.Query<Sys_BusiPortalMenu>().Where(t=>t.IsStopUsing==false).ToList();
              

            List<ViewModel.Sys_BusiPortalMenu> list_view_zree = new List<ViewModel.Sys_BusiPortalMenu>();
            var parent_list_qx_portmenu = list_qx_portmenu.Where(t => t.ParentOID == Guid.Empty).OrderBy(t => t.SortNo);
            foreach (var item in parent_list_qx_portmenu)
            {
                ViewModel.Sys_BusiPortalMenu ztree = new ViewModel.Sys_BusiPortalMenu();
                ztree.Sys_BusiPortalMenuOID = item.Sys_BusiPortalMenuOID;
                ztree.Name = item.Name;
                ztree.LinkBusiType = item.LinkBusiType;
                ztree.Route = item.Route;
                ztree.ImageLink = item.ImageLink;
                ztree.Param = item.Param;
                ztree.ParentOID = item.ParentOID;
                ztree.SortNo = item.SortNo;
                ztree.IsStopUsing = item.IsStopUsing;
                ztree.OpenMode = item.OpenMode;
                ztree.leves = 1;

                ztree.children = BuilTree(list_qx_portmenu, item.Sys_BusiPortalMenuOID, 1);
                list_view_zree.Add(ztree);
            }
            return list_view_zree;
        }
    }
}
