﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using G.MES.DataModel;
using G.MES.ViewModel;
using Common.Unit;
using G.Buss.System.ViewModel;
using Model = G.MES.DataModel;
using Chloe.SqlServer;
using System.Reflection;
using System.Data;
using System.Web;
using Chloe.Infrastructure.Interception;

namespace G.Buss.System
{
    public class Sys_AuditLogSvc : BaseSvc
    {
        public LoginInfo loginInfo { get; set; }
        /// <summary>
        /// 添加操作日志明细记录
        /// </summary>
        /// <param name="audit_log"></param>
        /// <returns></returns>
        public void AddAuditLog(List<Model.Sys_AuditLogDetailed> audit_log)
        {
            using (MsSqlContext context = new MsSqlContext(sqlConn))
            {
                try
                {
                    foreach (Model.Sys_AuditLogDetailed al in audit_log)
                    {
                        Model.Sys_AuditLogDetailed a_log = new Sys_AuditLogDetailed();
                        a_log.ActAfterValue = al.ActAfterValue;
                        a_log.ActBeforeValue = al.ActBeforeValue;
                        a_log.ActionParameters = al.ActionParameters;
                        a_log.ActionType = al.ActionType;
                        a_log.AuditOID = al.AuditOID;
                        a_log.TableName = al.TableName;
                        a_log.UserIP = al.UserIP;
                        context.Insert(a_log);
                    }
                    context.Session.CommitTransaction();
                }
                catch (Exception e)
                {
                    if (context.Session.IsInTransaction)
                    {
                        context.Session.RollbackTransaction();
                    }
                    Log4.Write().Error(MethodBase.GetCurrentMethod().Name + e.Message);
                }
            }
        }
        /// <summary>
        /// 添加操作日志记录主表
        /// </summary>
        /// <param name="but_resource"></param>
        /// <returns></returns>
        public void AddSysTemLogging(Model.SystemLogging logging)
        {
            using (MsSqlContext context = new MsSqlContext(sqlConn))
            {
                try
                {
                    SystemLogging loging = new SystemLogging();
                    loging.SysytemLoggingOID = logging.SysytemLoggingOID;
                    loging.EnterTime = logging.EnterTime;
                    loging.EndTime = logging.EndTime;
                    loging.CostTime = logging.CostTime;
                    loging.RequestUri = logging.RequestUri;
                    loging.RequestParamaters = logging.RequestParamaters;
                    loging.ResponseParamaters = logging.ResponseParamaters;
                    loging.UserIP = logging.UserIP;
                    loging.Browser = logging.Browser;
                    loging.Sys_User_FK = logging.Sys_User_FK;
                    context.Insert(loging);
                    context.Update<Model.Sys_AuditLogDetailed>(a => a.SysytemLogging_FK == null&& a.UserIP == logging.UserIP, a => new Model.Sys_AuditLogDetailed()
                    {
                        SysytemLogging_FK = logging.SysytemLoggingOID
                    });
                }
                catch (Exception e)
                {
                    Log4.Write().Error(MethodBase.GetCurrentMethod().Name + e.Message);
                }
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="strQuery"></param>
        /// <returns></returns>
        public List<string> GetBeforeValue(string strQuery)
        {
            List<string> beforeValues = new List<string>();
           SqlHelper sqlhelp = new SqlHelper();
            DataTable dtQuery = sqlhelp.ExcuteDatatable(strQuery);
            if (dtQuery.Rows.Count > 0)
            {
                for (int i = 0; i < dtQuery.Columns.Count; i++)
                {
                    beforeValues.Add(dtQuery.Rows[0][i].ToString());
                }
            }
            return beforeValues;
        }
    }
}
