﻿// --------------------------------------------------------------------------------------------------------------------
// <copyright file="UpdateExpressionsEntity.cs" >
//   Copyright © 2013
// </copyright>
// <summary>
//   更新表达式(批量更新时使用)
// </summary>
// --------------------------------------------------------------------------------------------------------------------



namespace G.MES.DataModel.Core
{
    using System;
    using System.Linq.Expressions;

    /// <summary>
    /// 更新表达式(批量更新时使用)
    /// </summary>
    /// <typeparam name="TEntity">
    /// TEntity
    /// </typeparam>
    public class UpdateExpressionsEntity<TEntity>
        where TEntity : class, new()
    {
        #region Constructors and Destructors

        /// <summary>
        /// Initializes a new instance of the <see cref="UpdateExpressionsEntity{TEntity}"/> class. 
        ///     构造函数
        /// </summary>
        public UpdateExpressionsEntity()
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UpdateExpressionsEntity{TEntity}"/> class. 
        /// 构造函数
        /// </summary>
        /// <param name="filterExpression">
        /// 过滤表达式
        /// </param>
        /// <param name="updateExpression">
        /// 更新表达式
        /// </param>
        public UpdateExpressionsEntity(
            Expression<Func<TEntity, bool>> filterExpression, 
            Expression<Func<TEntity, TEntity>> updateExpression)
            : this()
        {
            this.FilterExpression = filterExpression;
            this.UpdateExpression = updateExpression;
        }

        #endregion

        #region Public Properties

        /// <summary>
        ///     条件过滤表达式
        /// </summary>
        public Expression<Func<TEntity, bool>> FilterExpression { get; set; }

        /// <summary>
        ///     实体字段更新表达式
        /// </summary>
        public Expression<Func<TEntity, TEntity>> UpdateExpression { get; set; }

        #endregion
    }
}