﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Validation;
using System.Data.EntityClient;
using System.Linq;
using System.Configuration;
using System.Reflection;

namespace G.MES.DataAdapter
{
    public partial class EFContext<T> where T : class
    {
        private static DbContext CreateDbContext()
        {
            Type type = typeof(DbContext);
            var entityBuilder = new EntityConnectionStringBuilder();
            entityBuilder.Metadata = "res://*/DbModel.csdl|res://*/DbModel.ssdl|res://*/DbModel.msl";
            entityBuilder.Provider = "System.Data.SqlClient";
            entityBuilder.ProviderConnectionString = ConfigurationManager.ConnectionStrings["SQLSERVER"].ConnectionString;

            string entityBuilderString = entityBuilder.ToString();
            ConstructorInfo ctor = type.GetConstructor(new[] { typeof(string) });
            if (ctor == null)
            {
                throw new Exception("初始化数据上下文失败！");
            }

            var context = ctor.Invoke(new object[] { entityBuilderString }) as DbContext;
            return context;
        }

        private static IDbSet<T> _entities;
        public static IDbSet<T> Entities
        {
            get
            {
                if (_entities == null) {
                    using (DbContext context = CreateDbContext())
                    {
                        _entities= context.Set<T>();
                    }
                }
                return _entities;
            }
        }

    }
}
