﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace G.MES.ViewModel
{
    /// <summary>分页的实体</summary>
    public class PageData
    {
        private int _totalCount;
        /// <summary>当前页</summary>
        public int PageIndex { get; set; }
        /// <summary>每页数量</summary>
        public int PageSize { get; set; }
        /// <summary>总页数</summary>
        public int TotalSize { get; set; }
        /// <summary>总数据量</summary>
        public int TotalCount
        {
            get { return _totalCount; }
            set
            {
                _totalCount = value;
                int size = TotalCount / PageSize;
                double per = TotalCount % PageSize;
                if (per != 0)
                    size += 1;
                TotalSize = size;
            }
        }
        /// <summary>每页的数据</summary>
        public dynamic Data { get; set; }
        //public List<string> PaperAllList { get; set; }

        /// <summary>
        /// 组装page数据
        /// </summary>
        /// <param name="pageIndex">当前页</param>
        /// <param name="pageSize">每页数量</param>
        /// <param name="totalCount">总数量</param>
        /// <param name="data">当前页数据</param>
        /// <returns></returns>
        public static PageData Make(int pageIndex, int pageSize, int totalCount, dynamic data, List<string> PaperAllList = null)
        {
            PageData one = new PageData();
            one.PageIndex = pageIndex;
            one.PageSize = pageSize;
            one.TotalCount = totalCount;
            one.Data = data;
            return one;
        }



    }
}
