﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Nyd.Extend.Tool.NPOI;
using Spire.Doc;
using Spire.Doc.Documents;
using Xceed.Document.NET;
using Xceed.Words.NET;

namespace WordByDocx.Word
{
    public static class OperationFunc
    {
        public static void ReplaceFunc(this Spire.Doc.Document document, string oldString, string newString)
        {
            document.Replace(oldString, newString, false, true);
        }

        public static string ToLocalLongTime(this DateTime? dateTime)
        {
            if (dateTime == null)
            {
                return "";
            }
            return Convert.ToDateTime(dateTime.ToString()).ToString("YYYY-MM-dd");
        }
        /// <summary>
        /// 创建表格样式
        /// </summary>
        /// <param name="document"></param>
        /// <param name="color"></param>
        /// <param name="fontSizt"></param>
        /// <returns></returns>
        public static ParagraphStyle CreateTableStyle(this Spire.Doc.Document document, string textColor = "#000000", int fontSizt = 14)
        {
            Color C = System.Drawing.ColorTranslator.FromHtml(textColor);
            ParagraphStyle style = new ParagraphStyle(document);
            style.Name = "TableStyle";
            style.CharacterFormat.FontSize = fontSizt;
            style.CharacterFormat.TextColor = C;
            document.Styles.Add(style);
            return style;
        }


        public static readonly string BaseDic = @"F:\Work\Project\报告系统\Git\ReportingSystemAPI\UnitTestWord\bin\Debug\template\检测结果汇总表.xlsx";
        public static void GetExcel()
        {
            using (FileStream fileStream = new FileStream(BaseDic, FileMode.Open))
            {
                byte[] bytes = new byte[fileStream.Length];
                fileStream.Read(bytes, 0, bytes.Length);
                fileStream.Close();
                Stream stream = new MemoryStream(bytes);
                DataTable table = NPOIHelper.RenderDataTableFromExcel(stream, 0, 0);
            }
        }
    }
}
